diff --git a/src/main/java/net/minecraft/core/block/BlockFurnace.java b/src/main/java/net/minecraft/core/block/BlockFurnace.java
index 560cb0f63..1f14dd775 100644
--- a/src/main/java/net/minecraft/core/block/BlockFurnace.java
+++ b/src/main/java/net/minecraft/core/block/BlockFurnace.java
@@ -1,16 +1,16 @@
 package net.minecraft.core.block;
 
-import java.util.Random;
-
 import net.minecraft.core.Global;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityFurnace;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityFurnace;
-import net.minecraft.core.block.material.Material;
+
+import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, Block, World, 
@@ -65,23 +65,23 @@ public class BlockFurnace extends BlockTileEntityRotatable
         double f4 = rand.nextFloat() * 0.6F - 0.3F;
         if(l == 4)
         {
-            world.spawnParticle("smoke", poxX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", poxX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", poxX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", poxX - f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 5)
         {
-            world.spawnParticle("smoke", poxX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", poxX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", poxX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", poxX + f3, posY, posZ + f4, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 2)
         {
-            world.spawnParticle("smoke", poxX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", poxX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", poxX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", poxX + f4, posY, posZ - f3, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 3)
         {
-            world.spawnParticle("smoke", poxX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", poxX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", poxX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", poxX + f4, posY, posZ + f3, 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockGrass.java b/src/main/java/net/minecraft/core/block/BlockGrass.java
index d0317fe91..fe1d7d72e 100644
--- a/src/main/java/net/minecraft/core/block/BlockGrass.java
+++ b/src/main/java/net/minecraft/core/block/BlockGrass.java
@@ -69,7 +69,7 @@ public class BlockGrass extends Block
                         idToSpawn = Block.flowerPink.id;
                     } else if (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND) {
                         idToSpawn = Block.flowerPurple.id;
-                    } else if (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_CAATINGA) {
+                    } else if (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_CAATINGA) {
                         idToSpawn = Block.flowerLightBlue.id;
                     }
                 } else {
diff --git a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java b/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
index 0f6aa5149..8278fb1fe 100644
--- a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
+++ b/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
@@ -72,7 +72,7 @@ public class BlockLanternFirefly extends Block{
     {
         if(rand.nextInt(3)==0)
         {
-            world.spawnParticle(color.getParticleName(), (double)x + rand.nextFloat(), (double)y + rand.nextFloat(), (double) z + rand.nextFloat(), 0.0D, 0.0D, 0.0D);
+            world.spawnParticle(color.getParticleName(), (double)x + rand.nextFloat(), (double)y + rand.nextFloat(), (double) z + rand.nextFloat(), 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java b/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
index 19546388a..5601114a8 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
@@ -25,7 +25,7 @@ public class BlockLeavesCherry extends BlockLeavesBase
     {
         if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING && rand.nextInt(40) == 0)
         {
-            world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0);
+            world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0, 0);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java b/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
index c74cad9b3..a0cfebe4b 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
@@ -30,7 +30,7 @@ public class BlockLeavesEucalyptus extends BlockLeavesBase
     {
     	if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0)
     	{
-    		world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0);
+    		world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0, 0);
     	}
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesOak.java b/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
index f3f8bbd14..de34c8669 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
@@ -58,7 +58,7 @@ public class BlockLeavesOak extends BlockLeavesBase
             float windIntensity = wind.getWindIntensity(world, x, y, z);
             if (rand.nextInt((int)(40 + 200 * (1 - windIntensity))) == 0)
             {
-                world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0);
+                world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0, 0);
             }
     	}
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java b/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
index 7dcb14aea..7a0bb876a 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
@@ -30,7 +30,7 @@ public class BlockLeavesShrub extends BlockLeavesBase
     {
         if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0)
         {
-            world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0);
+            world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0, 0);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockMotionSensor.java b/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
index 16b15db68..eccff28f3 100644
--- a/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
+++ b/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
@@ -85,7 +85,7 @@ public class BlockMotionSensor extends BlockTileEntityRotatable
 			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue);
+				world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockMud.java b/src/main/java/net/minecraft/core/block/BlockMud.java
index ba6819318..9c051dc50 100644
--- a/src/main/java/net/minecraft/core/block/BlockMud.java
+++ b/src/main/java/net/minecraft/core/block/BlockMud.java
@@ -178,7 +178,7 @@ public class BlockMud extends Block{
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
                 for(int l = 0; l < 8; l++)
                 {
-                    world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D);
+                    world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
                 }
                 world.setBlock(x, y, z, Block.mudBaked.id);
                 world.notifyBlockChange(x, y, z, Block.mudBaked.id);
diff --git a/src/main/java/net/minecraft/core/block/BlockNote.java b/src/main/java/net/minecraft/core/block/BlockNote.java
index aa6847cb3..a67449bb4 100644
--- a/src/main/java/net/minecraft/core/block/BlockNote.java
+++ b/src/main/java/net/minecraft/core/block/BlockNote.java
@@ -95,6 +95,6 @@ public class BlockNote extends BlockTileEntity
             s = "bassattack";
         }
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, (new StringBuilder()).append("note.").append(s).toString(), 3F, f);
-        world.spawnParticle("note", (double) x + 0.5D, (double) y + 1.2D, (double) z + 0.5D, (double) data / 24D, 0.0D, 0.0D);
+        world.spawnParticle("note", (double) x + 0.5D, (double) y + 1.2D, (double) z + 0.5D, (double) data / 24D, 0.0D, 0.0D, 0);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
index 985c56972..fe4305123 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
+++ b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
@@ -8,7 +8,6 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.client.util.helper.Colors;
-import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
@@ -124,7 +123,7 @@ public class BlockOreRedstone extends Block
 			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue);
+				world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
 			}
 		}
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockPortal.java b/src/main/java/net/minecraft/core/block/BlockPortal.java
index 419585e3c..96b9086b9 100644
--- a/src/main/java/net/minecraft/core/block/BlockPortal.java
+++ b/src/main/java/net/minecraft/core/block/BlockPortal.java
@@ -342,7 +342,7 @@ public class BlockPortal extends BlockTransparent
                 d = (double) x + 0.5D + 0.25D * (double)i1;
                 d3 = rand.nextFloat() * 2.0D * (double)i1;
             }
-            world.spawnParticle("portal", d, d1, d2, d3, d4, d5);
+            world.spawnParticle("portal", d, d1, d2, d3, d4, d5, 0);
         }
 
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstone.java b/src/main/java/net/minecraft/core/block/BlockRedstone.java
index f11810e35..400adb7f8 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstone.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstone.java
@@ -87,7 +87,7 @@ public class BlockRedstone extends Block
 			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue);
+				world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java b/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
index 7d685ad41..402f83cff 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
@@ -253,7 +253,7 @@ public class BlockRedstoneRepeater extends Block
 				break;
 			}
 		}
-		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, red, green, blue);
+		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, red, green, blue, 0);
 	}
 
     public static final double field_22024_a[] = {
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java b/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
index 376e0c73f..eb26cb3a2 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
@@ -154,7 +154,7 @@ public class BlockRedstoneTorch extends BlockTorch
                         double d = (double) x + rand.nextDouble() * 0.6D + 0.2D;
                         double d1 = (double) y + rand.nextDouble() * 0.6D + 0.2D;
                         double d2 = (double) z + rand.nextDouble() * 0.6D + 0.2D;
-                        world.spawnParticle("smoke", d, d1, d2, 0.0D, 0.0D, 0.0D);
+                        world.spawnParticle("smoke", d, d1, d2, 0.0D, 0.0D, 0.0D, 0);
                     }
                 }
             }
@@ -219,15 +219,15 @@ public class BlockRedstoneTorch extends BlockTorch
 		float blue = color.getBlue() / 255.0f;
 		
 		if (meta == 1) {
-			world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue);
+			world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue, 0);
 		} else if (meta == 2) {
-			world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue);
+			world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue, 0);
 		} else if (meta == 3) {
-			world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue);
+			world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue, 0);
 		} else if (meta == 4) {
-			world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue);
+			world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue, 0);
 		} else {
-			world.spawnParticle("reddust", px, py, pz, red, green, blue);
+			world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
 		}
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java b/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
index d9f4cb344..67ece3c5a 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
@@ -435,7 +435,7 @@ public class BlockRedstoneWire extends Block
 		float green = color.getGreen() / 255.0f;
 		float blue = color.getBlue() / 255.0f;
 
-		world.spawnParticle("reddust", px, py, pz, red, green, blue);
+		world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
 	}
 
     public static boolean isPowerProviderOrWire(WorldSource iblockaccess, int i, int j, int k, int l)
diff --git a/src/main/java/net/minecraft/core/block/BlockSponge.java b/src/main/java/net/minecraft/core/block/BlockSponge.java
index 1a4049079..01c82464e 100644
--- a/src/main/java/net/minecraft/core/block/BlockSponge.java
+++ b/src/main/java/net/minecraft/core/block/BlockSponge.java
@@ -29,7 +29,7 @@ public class BlockSponge extends Block
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
             {
-                world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D);
+                world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
             }
         }
         if(!isWet && inWater(world, x, y, z)) {
diff --git a/src/main/java/net/minecraft/core/block/BlockStone.java b/src/main/java/net/minecraft/core/block/BlockStone.java
index c2415ad80..14604589e 100644
--- a/src/main/java/net/minecraft/core/block/BlockStone.java
+++ b/src/main/java/net/minecraft/core/block/BlockStone.java
@@ -37,7 +37,7 @@ public class BlockStone extends Block {
         Chunk chunk = world.getChunkFromBlockCoords(x, z);
 		if (y <= 32 && chunk.getChunkRandom(0x3ad8025fL).nextInt(10) == 0 && world.getBlockId(x, y - 1, z) == 0) {
 			if (rand.nextInt(50) == 0)
-				world.spawnParticle("slimechunk", x, y, z, 0.0D, 0.0D, 0.0D);
+				world.spawnParticle("slimechunk", x, y, z, 0.0D, 0.0D, 0.0D, 0);
 		}
 	}
 	
diff --git a/src/main/java/net/minecraft/core/block/BlockTorch.java b/src/main/java/net/minecraft/core/block/BlockTorch.java
index 00b469fb5..248a1700a 100644
--- a/src/main/java/net/minecraft/core/block/BlockTorch.java
+++ b/src/main/java/net/minecraft/core/block/BlockTorch.java
@@ -1,7 +1,5 @@
 package net.minecraft.core.block;
 
-import java.util.Random;
-
 import net.minecraft.core.HitResult;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLiving;
@@ -12,6 +10,8 @@ import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
+import java.util.Random;
+
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
 //            Vec3D, MovingObjectPosition
@@ -221,27 +221,27 @@ public class BlockTorch extends Block
         double d4 = 0.27D;
         if(l == 1)
         {
-            world.spawnParticle("smoke", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", xPos - d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 2)
         {
-            world.spawnParticle("smoke", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", xPos + d4, yPos + d3, zPos, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 3)
         {
-            world.spawnParticle("smoke", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", xPos, yPos + d3, zPos - d4, 0.0D, 0.0D, 0.0D, 0);
         } else
         if(l == 4)
         {
-            world.spawnParticle("smoke", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", xPos, yPos + d3, zPos + d4, 0.0D, 0.0D, 0.0D, 0);
         } else
         {
-            world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
-            world.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
         }
     }
     
diff --git a/src/main/java/net/minecraft/core/block/BlockTrommel.java b/src/main/java/net/minecraft/core/block/BlockTrommel.java
index 1c4dc8ffc..d1a330dd1 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrommel.java
+++ b/src/main/java/net/minecraft/core/block/BlockTrommel.java
@@ -1,16 +1,16 @@
 package net.minecraft.core.block;
 
-import java.util.Random;
-
 import net.minecraft.core.Global;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityTrommel;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityTrommel;
-import net.minecraft.core.block.material.Material;
+
+import java.util.Random;
 
 public class BlockTrommel extends BlockTileEntityRotatable
 {
@@ -61,7 +61,7 @@ public class BlockTrommel extends BlockTileEntityRotatable
         double xPos = (double) x + rand.nextFloat();
         double yPos = (double) y + rand.nextFloat() * 0.5D + 1D;
         double zPos = (double) z + rand.nextFloat();
-        world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
+        world.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
     }
     
     public static void updateTrommelBlockState(boolean flag, World world, int i, int j, int k)
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 7aaeed0b6..a5776d35d 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -63,8 +63,8 @@ public class TileEntityMobSpawner extends TileEntity
         double xPos = (double) x + worldObj.rand.nextFloat();
         double yPos = (double) y + worldObj.rand.nextFloat();
         double zPos = (double) z + worldObj.rand.nextFloat();
-        worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
-        worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
+        worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+        worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
         for(yaw += 1000F / ((float)delay + 200F); yaw > 360D;)
         {
             yaw -= 360D;
@@ -130,8 +130,8 @@ public class TileEntityMobSpawner extends TileEntity
                     double d1 = (double) x + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
                     double d3 = (double) y + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
                     double d5 = (double) z + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
-                    worldObj.spawnParticle("smoke", d1, d3, d5, 0.0D, 0.0D, 0.0D);
-                    worldObj.spawnParticle("flame", d1, d3, d5, 0.0D, 0.0D, 0.0D);
+                    worldObj.spawnParticle("smoke", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
+                    worldObj.spawnParticle("flame", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
                     worldObj.playSoundAtEntity(null, entityliving, "mob.ghast.fireball", 0.025F, 0.75F);
                 }
 
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index 1817e7995..cf12da4c0 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -1,13 +1,9 @@
 package net.minecraft.core.entity;
 
-import java.util.List;
-import java.util.Random;
-
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.DoubleTag;
 import com.mojang.nbt.FloatTag;
 import com.mojang.nbt.ListTag;
-
 import net.minecraft.client.gui.guidebook.mobs.MobInfoRegistry;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.Global;
@@ -28,6 +24,9 @@ import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.SynchedEntityData;
 
+import java.util.List;
+import java.util.Random;
+
 public abstract class Entity
     implements IVehicle
 {
@@ -237,23 +236,26 @@ public abstract class Entity
         zo = z;
         xRotO = xRot;
         yRotO = yRot;
-        if (isSprinting())
-        {
-            int x = MathHelper.floor_double(this.x);
-            int y = MathHelper.floor_double(this.y - 0.2 - (double)heightOffset);
-            int z = MathHelper.floor_double(this.z);
-            int floorBlock = world.getBlockId(x, y, z);
-            if (floorBlock > 0)
-            {
-                world.spawnParticle("tilecrack_" + floorBlock,
-                    this.x + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
-                    bb.minY + 0.1,
-                    this.z + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
-                    -xd * 4D,
-                    1.5D,
-                    -zd * 4D);
-            }
-        }
+        // Removed at jonks request, should work though if it ever wants to be uncommented
+//        if (isSprinting())
+//        {
+//            int x = MathHelper.floor_double(this.x);
+//            int y = MathHelper.floor_double(this.y - 0.2 - (double)heightOffset);
+//            int z = MathHelper.floor_double(this.z);
+//            int floorBlock = world.getBlockId(x, y, z);
+//            int meta = world.getBlockMetadata(x, y, z);
+//            if (floorBlock > 0)
+//            {
+//                world.spawnParticle("block",
+//                    this.x + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
+//                    bb.minY + 0.1,
+//                    this.z + ((double)random.nextFloat() - 0.5D) * (double)bbWidth,
+//                    -xd * 4D,
+//                    1.5D,
+//                    -zd * 4D,
+//                        BlockParticleHelper.encodeBlockData(floorBlock, meta, Side.TOP));
+//            }
+//        }
 
         checkOnWater(true);
 
@@ -327,14 +329,14 @@ public abstract class Entity
                 {
                     double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
                     double offZ = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                    world.spawnParticle("bubble", x + offX, f1 + 1.0F, z + offZ, xd, yd - (double)(random.nextFloat() * 0.2F), zd);
+                    world.spawnParticle("bubble", x + offX, f1 + 1.0F, z + offZ, xd, yd - (double)(random.nextFloat() * 0.2F), zd, 0);
                 }
 
                 for(int j = 0; (float)j < 1.0F + bbWidth * 20F; j++)
                 {
                     double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
                     double offZ = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                    world.spawnParticle("splash", x + offX, f1 + 1.0F, z + offZ, xd, yd, zd);
+                    world.spawnParticle("splash", x + offX, f1 + 1.0F, z + offZ, xd, yd, zd, 0);
                 }
             }
             fallDistance = 0.0F;
@@ -803,6 +805,11 @@ public abstract class Entity
     }
     
     public int getLightmapCoord(float partialTicks) {
+    	if(world == null) {
+    		// Happens when the guidebook is rendered
+    		return LightmapHelper.getLightmapCoord(15, 15);
+    	}
+    	
     	int blockX = MathHelper.floor_double(x);
     	int blockY = MathHelper.floor_double(y);
     	int blockZ = MathHelper.floor_double(z);
diff --git a/src/main/java/net/minecraft/core/entity/EntityBobber.java b/src/main/java/net/minecraft/core/entity/EntityBobber.java
index b85e5663a..98a846379 100644
--- a/src/main/java/net/minecraft/core/entity/EntityBobber.java
+++ b/src/main/java/net/minecraft/core/entity/EntityBobber.java
@@ -300,14 +300,14 @@ public class EntityBobber extends Entity
                     {
                         double xOff = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
                         double zOff = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                        world.spawnParticle("bubble", x + xOff, f3 + 1.0F, z + zOff, xd, yd - (double)(random.nextFloat() * 0.2F), zd);
+                        world.spawnParticle("bubble", x + xOff, f3 + 1.0F, z + zOff, xd, yd - (double)(random.nextFloat() * 0.2F), zd, 0);
                     }
 
                     for(int j1 = 0; (float)j1 < 1.0F + bbWidth * 20F; j1++)
                     {
                         double xOff = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
                         double zOff = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                        world.spawnParticle("splash", x + xOff, f3 + 1.0F, z + zOff, xd, yd, zd);
+                        world.spawnParticle("splash", x + xOff, f3 + 1.0F, z + zOff, xd, yd, zd, 0);
                     }
 
                 }
